'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generatorFunction;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function allObjectKeys(obj) {
  var result = [];
  /* eslint-disable guard-for-in */
  for (var prop in obj) {
    result.push(prop);
  }

  return result;
}

function arrIncludes(arr, value) {
  return arr.indexOf(value) > -1;
}

function generatorFunction(component) {
  var prototypeKeys = allObjectKeys(component.prototype);
  var keys = allObjectKeys(component);

  // es5 React Component
  if (arrIncludes(prototypeKeys, 'constructor') && arrIncludes(prototypeKeys, 'render')) {
    return false;
  } else if (arrIncludes(prototypeKeys, 'isReactComponent') // es6 React Component
   || arrIncludes(keys, 'propTypes') || component.prototype instanceof _react2.default.Component) {
    return false;
  }

  // Else, we assume a generator function!
  return true;
}